# ircfuz

Faux-IRCd to detect client versions through handshake behavior

Currently (2019-07-04) detects: aicia, androirc, bitchx, burd, erc, hexchat, icechat, igloo, ii, irccloud, irssi, kiwiirc, konversation, limechat, mibbit, mirc, mutter, palaver, pidgin, polari, qicr, quassel, revolution, sic, textual, thelounge, weechat, znc

## detection methods

- `PING :123` -> `PONG :123` OR `PONG 123` (`pong_colon`)
- `PONG`ing an invalidly long `PING` (`longpong`)
- `longpong` causing an overflow (`longpong_overflow`)
- `PING` tokens being cut at space (`spacepong`)
- not recognising `ping` as `PING` (`lowerpong`)
- `PING a :twoping` -> `PONG :a twoping` (`twopong`)
- `PING a :twoping` -> `PONG twoping` (`twopong_cut`)
- `NICK` before `USER` (`nick_first`)
- `USER` disused params (`user_hostname` and `user_servername`)
- `PROTOCTL` in response to `NAMESX` (`protoctl`)
- IRCv3 support (`cap`)
- IRCv3.2 CAP dance (`cap_302`)
- count of `CAP REQ` lines (`cap_req_count`)
- If the client sent `CAP LIST` (`cap_list`)
